import { FieldNullability, InputFieldMap, SchemaTypes, ShapeFromTypeParam, TypeParam } from '@giraphql/core';
import { ErrorFieldOptions, ErrorsPluginOptions } from './types';
import { GiraphQLErrorsPlugin } from '.';
declare global {
    export namespace GiraphQLSchemaTypes {
        interface Plugins<Types extends SchemaTypes> {
            errors: GiraphQLErrorsPlugin<Types>;
        }
        interface SchemaBuilderOptions<Types extends SchemaTypes> {
            errorOptions?: ErrorsPluginOptions;
        }
        interface FieldOptions<Types extends SchemaTypes = SchemaTypes, ParentShape = unknown, Type extends TypeParam<Types> = TypeParam<Types>, Nullable extends FieldNullability<Type> = FieldNullability<Type>, Args extends InputFieldMap = InputFieldMap, ResolveShape = unknown, ResolveReturnShape = unknown> {
            errors?: ErrorFieldOptions<Types, Type, ShapeFromTypeParam<Types, Type, false>, Nullable>;
        }
    }
}
//# sourceMappingURL=global-types.d.ts.map